#include <stdio.h>
#include <math.h>
#define n 39000
FILE *fp;
float ax[n],ay[n],am[n],aw[n], bx[n],by[n],bm[n],bw[n];
float vm[n],vw[n];
int   na,nb;
char name[3][6]={"psf","best","petro"};
char namp[3]={ 71,98,111};
int  ip=0;

main(int ac,char **av)
{
  int i,j,k,k1,k2,m;
  char f1[30],t[70],a[201];
  float x1,x2,x3,x4,x5,x6,x7;
  float x,y,z,r,r0=1.;
  if(ac<3){ printf("\n\t ******  check 2_version Mag of a*.cat *******\n");
            printf("\n\t Usage: chboka a*.cat b*.cat [psf,best,petro]\n\n");
            exit(0);
          }
  if(ac>3){
    for(j=0;j<3;j++){ k=0;
      for(i=0;i<3;i++)if(name[j][i]==av[3][i])k++; if(k==3)ip=j;
    }
  }
  fp=fopen(av[1],"r");if(!fp){printf("\n\t%s file not found!\n",av[1]);exit(0);}
  na=0; k=namp[ip];
l10:
  fgets(a,201,fp); if(feof(fp))goto l20;
  if(a[0]=='#')goto l10;
  sscanf(&a[32],"%f%f%f%f",&x1,&x2,&x3,&x4);
  sscanf(&a[k],"%f%f",&x6,&x7);
  if(x6<5. || x6>30.)goto l10; 
  if(x7==0.)x7=0.001;
  if(ip){ x1=x3; x2=x4; };
  ax[na]=x1; ay[na]=x2; am[na]=x6; aw[na]=1./x7;
  na++; if(na<n-1)goto l10;
l20:
  fclose(fp);  printf("readin %s_star: %d\n",av[1],na);

  fp=fopen(av[2],"r");if(!fp){printf("\n\t%s file not found!\n",av[2]);exit(0);}
  nb=0;
l30:
  fgets(a,201,fp); if(feof(fp))goto l40;
  if(a[0]=='#')goto l30;
  sscanf(&a[32],"%f%f%f%f%",&x1,&x2,&x3,&x4);
  sscanf(&a[k],"%f%f",&x6,&x7);
  if(x6<5. || x6>30.)goto l30; 
  if(x7==0.)x7=0.001;
  if(ip){ x1=x3; x2=x4; };
  bx[nb]=x1; by[nb]=x2; bm[nb]=x6; bw[nb]=1./x7;
  nb++; if(nb<n-1)goto l30;
l40:
  fclose(fp);  printf("readin %s_star: %d\n",av[2],nb);

  m=0; k1=0; k2=k1+60;
  for(i=0;i<na;i++){  r=r0; vw[i]=-1.;
    for(j=k1;j<k2;j++){
      x=bx[j]-ax[i]; y=by[j]-ay[i];
      z=x*x+y*y; if(z<r){ k=j; r=z; }
    }
    if(r0!=r){ m++; vm[i]=bm[k]-am[i]; 
                    vw[i]=bw[k]*bw[k]+aw[i]*aw[i]; }
    k1=k-30; k2=k+30; if(k1<0)k1=0; if(k2>nb)k2=nb;
  }
  printf("***** %s *******\n",name[ip]);
  printf("position_matched_star: %d in 0.55 arcsec\n",m);
  avsig(vm,vw,na,&x1,&x2,&j);
  sprintf(t,"%8.4f  +-%6.4f  %d/%d",x1,x2,j,m);  printf("%s\n",t);

int aa[101];
  for(i=0;i<101;i++)aa[i]=0;
  for(i=0;i<na;i++)if(vw[i]!=-1. && vm[i]>-0.05 && vm[i]<0.05){
    k=(vm[i]+0.05)*1000.+0.5; 
    aa[k]++; 
  }

int i0,i1,i2,i3;
float ss[2],tt[2];
  i0=0; i1=1; i2=2; i3=3; 
  pgbegin_(&i0,"/xw",&i1,&i1,3);
  x1=800., x2=500.;                  pgpap_(&x1,&x2);
  x1=9.; x2=26.; x3=-0.05; x4=.05;   pgenv_(&x1,&x2,&x3,&x4,&i0,&i0);
  ss[0]=x1; ss[1]=x2; tt[0]=tt[1]=0; pgsci_(&i2); pgline_(&i2,ss,tt); 
  pgsci_(&i1);  x1=10.; x2=0.03;     pgtext_(&x1,&x2,t,strlen(t));
                x1=10.; x2=0.035;    pgtext_(&x1,&x2,name[ip],strlen(name[ip]));
  for(j=0;j<na;j++)if(vw[j]!=-1.)pgpoint_(&i1,&am[j],&vm[j],&i1); 
  sprintf(t,"%s - %s",av[2],av[1]);
  pglabel_(av[1],"Magnitude_diffence",t,strlen(av[1]),18,strlen(t));

k=101;
  for(i=0;i<k;i++){
    ax[i]=aa[i]*0.002+9.0;
    ay[i]=i*.001-0.05;
//    printf("%f %f\n",ax[i],ay[i]);
  }
pgsci_(&i3); 
pgline_(&k,ax,ay);
  
  pgend_();    
} 

avsig(v,w,m,a,s,mm)
float *v,*w,*a,*s; int m,*mm;
{
  int i,j,k; float x,xx,xk,aa,ss;
l10:
  x=xk=0.; for(i=k=0;i<m;i++)if(w[i]>0.){x+=v[i]*w[i]; xk+=w[i]; k++; } aa=x/xk;
  xx=0.;for(i=0;i<m;i++)if(w[i]>0.)xx+=(v[i]-aa)*(v[i]-aa)*w[i]; ss=sqrt(xx/xk);
  for(i=j=0;i<m;i++)if(w[i]>0.){
    x=v[i]-aa; if(x<0.)x=-x; if(x>ss*3.){ w[i]=-w[i]; j++; }
  } if(j)goto l10;
  *mm=k; *a=aa; *s=ss;
}
